Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};
var developmentStatusesScript = developmentStatusesScript || function () {
    var isInit = false;
    var developmentStatusListingDataTable = null;
    var selectedDevelopmentStatuses = [];

    var init = function () {
        if (isInit) return;
        isInit = true;
        handler();
    };

    var handler = function () {
        developmentStatusListDataTable();
        globalScript.initValidator();
        initEditor();

        $("body").on('click', '.select_all', function () { // bulk checked
            var status = this.checked;
            if (status === true) {
                $('#bulk-action-checkbox').prop('checked', true);
                $('body').find(".bulkRow").each(function () {
                    $(this).prop("checked", status);
                    var roleId = $(this).closest('tr').find('.developmentStatus-id').val();
                    if (selectedDevelopmentStatuses.indexOf(roleId) === -1) {
                        selectedDevelopmentStatuses.push(roleId);
                    }
                });
            } else {
                $(".bulkRow, .select_all").prop('checked', false);
                $('#bulk-action-checkbox').prop('checked', false);
                selectedDevelopmentStatuses = [];
            }
        });

        $('body').on('click', '.bulkRow', function () {
            var status = this.checked;
            var roleId = $(this).closest('tr').find('.developmentStatus-id').val();
            if (status === true) {
                if (selectedDevelopmentStatuses.indexOf(roleId) === -1) {
                    selectedDevelopmentStatuses.push(roleId);
                }
                $('#bulk-action-checkbox').prop('checked', true);
            } else {
                selectedDevelopmentStatuses.remove(roleId);
            }
            if (selectedDevelopmentStatuses.length === 0) {
                $(".bulkRow, .select_all").prop('checked', false);
            }
        });

        $('body').on('click', '#apply_bulk_actions_btn', function () {
            var bulkOption = $('#bulk_actions').val();
            if (bulkOption === '') {
                $('#bulk_actions_error').html('Please select an action first').show();
            } else {
                if (selectedDevelopmentStatuses.length === 0) {
                    $('#bulk_actions_error').html('Please select developmentStatus(s) first').show();
                } else {
                    $('#bulk_actions_error').hide();
                    if (bulkOption === 'delete_bulk') {
                        globalScript.showConfirmationAlert(
                            'You want to delete selected developmentStatus(s)?',
                            function () {
                                deleteDevelopmentStatuses(function () {
                                    toastr.success('DevelopmentStatus(s) deleted successfully');
                                    developmentStatusListDataTable();
                                    $(".bulkRow, .select_all").prop('checked', false);
                                });
                            }
                        )
                    }
                }
            }
        });

        $('body').on('submit', '#create_developmentStatus_form', function (e) {
            e.preventDefault();
            if ($('#submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#submit_btn').addClass('disabled');
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            var developmentStatus_name = $('#developmentStatus_name').val();
            var developmentStatus_meta_title = $('#developmentStatus_meta_title').val();
            var developmentStatus_meta_keywords = $('#developmentStatus_meta_keywords').val();
            var developmentStatus_meta_description = $('#developmentStatus_meta_description').val();
            var developmentStatus_full_description = $('#developmentStatus_full_description').summernote('code');
            var obj = Object.create(globalScript.CREATE_ATTRIBUTE);
            obj.data = {
                'type': 'developmentStatus',
                'name': developmentStatus_name,
                'full_desc': developmentStatus_full_description,
                'meta_title': developmentStatus_meta_title,
                'meta_keywords': developmentStatus_meta_keywords,
                'meta_desc': developmentStatus_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('.add_errors').show();
                    $('#submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.add_errors ul').append('<li>' + v + '</li>');
                    });
                    return false;
                } else {
                    toastr.success(response._metadata.message);
                    // setTimeout(function () { window.developmentStatus.reload() }, 500)
                    $('#addDevelopmentStatusModal').modal('hide');
                    developmentStatusListDataTable();
                }
            });
        });

        $('body').on('submit', '#edit_developmentStatus_form', function (e) {
            e.preventDefault();
            if ($('#edit_submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#edit_submit_btn').addClass('disabled');
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            var developmentStatusId = $('#developmentStatus_id').val();
            var developmentStatus_name = $('#edit_developmentStatus_name').val();
            var developmentStatus_meta_title = $('#edit_developmentStatus_meta_title').val();
            var developmentStatus_meta_keywords = $('#edit_developmentStatus_meta_keywords').val();
            var developmentStatus_meta_description = $('#edit_developmentStatus_meta_description').val();
            var developmentStatus_full_description = $('#edit_developmentStatus_full_description').summernote('code');
            var obj = Object.create(globalScript.UPDATE_ATTRIBUTE);
            obj.url = obj.url(developmentStatusId);
            obj.data = {
                'name': developmentStatus_name,
                'full_desc': developmentStatus_full_description,
                'meta_title': developmentStatus_meta_title,
                'meta_keywords': developmentStatus_meta_keywords,
                'meta_desc': developmentStatus_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('#edit_submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.edit_errors ul').append('<li>' + v + '</li>');
                        $('.edit_errors').show();
                    });
                } else {
                    toastr.success(response._metadata.message);
                    // setTimeout(function () { window.developmentStatus.reload() }, 500)
                    $('#editDevelopmentStatusModal').modal('hide');
                    developmentStatusListDataTable();
                }
            });
        });

        $('body').on('click', '.edit-btn', function () {
            var developmentStatusId = $(this).closest('tr').find('.developmentStatus-id').val();
            var obj = Object.create(globalScript.GET_ATTRIBUTE_DETAILS);
            var url = obj.url(developmentStatusId);
            obj.url = url;
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.hasOwnProperty('_metadata') && response._metadata.hasOwnProperty('outcomeCode') && response._metadata.outcomeCode === 0) {
                    $('body').find('#developmentStatus_id').val(response.records.id);
                    $('body').find('#edit_developmentStatus_form #edit_developmentStatus_name').val(response.records.name);
                    $('body').find('#edit_developmentStatus_form #edit_developmentStatus_meta_title').val(response.records.meta_title);
                    $('body').find('#edit_developmentStatus_form #edit_developmentStatus_meta_keywords').val(response.records.meta_keywords);
                    $('body').find('#edit_developmentStatus_form #edit_developmentStatus_meta_description').val(response.records.meta_desc);
                    $('body').find('#edit_developmentStatus_form #edit_developmentStatus_full_description').summernote("code", response.records.full_desc);
                    $('.edit_errors').hide();
                    $('.edit_errors ul').html('');
                    $('#editDevelopmentStatusModal').modal('show');
                }
            })
        });

        $('body').on('click', '.delete-btn', function () {
            selectedDevelopmentStatuses = [];
            $(".bulkRow, .select_all").prop('checked', false);
            var developmentStatusId = $(this).closest('tr').find('.developmentStatus-id').val();
            selectedDevelopmentStatuses.push(developmentStatusId);
            globalScript.showConfirmationAlert(
                'You want to delete?',
                function () {
                    deleteDevelopmentStatuses(function () {
                        toastr.success('Deleted successfully');
                        developmentStatusListDataTable();
                    });
                }
            )
        });

        $('#addDevelopmentStatusModal').on('hidden.bs.modal', function (e) {
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            $('#create_developmentStatus_form').trigger("reset");
            $('#developmentStatus_full_description').summernote('reset');
        });

        $('#editDevelopmentStatusModal').on('hidden.bs.modal', function (e) {
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            $('#edit_developmentStatus_form').trigger("reset");
            $('#edit_developmentStatus_full_description').summernote('reset');
        });
    };

    var deleteDevelopmentStatuses = function (callback) {
        var obj = Object.create(globalScript.DELETE_ATTRIBUTE);
        obj.data = {
            'attribute_ids[]': selectedDevelopmentStatuses
        };
        globalScript.ajaxCall(obj).done(function (response) {
            selectedDevelopmentStatuses = [];
            if (typeof callback == 'function') callback();
        });
    };

    var developmentStatusListDataTable = function () {
        if (developmentStatusListingDataTable != null) {
            developmentStatusListingDataTable.clear().destroy();
        }
        developmentStatusListingDataTable = $('#developmentStatusesListTable').DataTable({
            "ajax": {
                url: globalScript.APP_URL + "attributes?type=developmentStatus",
                type: "GET",
                xhrFields: {
                    withCredentials: true
                },
                dataSrc: function (json) {
                    if (json.hasOwnProperty('_metadata') && json._metadata.hasOwnProperty('outcomeCode') && json._metadata.outcomeCode === 4) {
                        window.top.location.href = "login";
                        return;
                    }
                    json.draw = json.records.draw;
                    json.recordsTotal = json.records.recordsTotal;
                    json.recordsFiltered = json.records.recordsFiltered;
                    $('body').find('#module_total_count').html(json.records.recordsTotal);
                    if (json.records.data.length !== 0) {
                        $("body").find(".f_custom_checkbox").css('pointer-events', 'all');
                        $("body").find(".f_custom_card_footer").show();
                    } else {
                        $("body").find(".f_custom_card_footer").hide();
                    }
                    return json.records.data;
                }
            },
            "searching": true,
            "ordering": true,
            "serverSide": true,
            "paging": true,
            "stateSave": false,
            "columns": [
                {
                    "orderable": true,
                    "searchable": false,
                    "data": 'created_at',
                    "visible": false
                },
                {
                    "data": "name",
                    "title": "Title",
                    "name": "name",
                    "searchable": true,
                    "orderable": true
                },
                {
                    "data": null,
                    "title": "Actions",
                    "searchable": false,
                    "orderable": false
                }
            ],
            "order": [[0, 'desc']],
            "rowCallback": function (row, data) {
                var tmpl = _.template($('#developmentStatusesListTemplate').html());
                $(row).html(tmpl(data));
            }
        });
    };

    var initEditor = function () {
        $('.content_area').summernote({
            onCreateLink: function (originalLink) {
                return originalLink; // return original link
            },
            dialogsInBody: true,
            height: 300,
            tabsize: 2
        });
    };

    return {
        'init': init
    }

}();

$(document).ready(function () {
    developmentStatusesScript.init();
});
